#include <stdio.h>
#include <conio.h>
#include <graphics.h>
#include "mys.h"

#define NULL 0

typedef int barva;

class Polozka {
 protected:

  int x, y;
  int sirka, vyska;
  barva pozadi, popredi;
  char *text;
  int obnovit, on, down;

 public:

  Polozka();
  Polozka(int, int, int, int);
  void kresli();

  void setBarva(barva, barva);
  void setText(char *);
  void setOn();
  void resetOn();
  void setDown();
  void resetDown();

  int getX();
  int getY();
  int getSirka();
  int getVyska();
  int getObnovit();
  int getOn();
  int getDown();

  virtual void mouseOn(){}
  virtual void mouseOff(){}
  virtual void mouseClick(){}
};

Polozka::Polozka() {
}

Polozka::Polozka(int xx, int yy, int s, int v) {
  x = xx;
  y = yy;
  sirka = s;
  vyska = v;
  text = "Polozka";
  pozadi = 1;
  popredi = 14;
  obnovit = 1;
  on = 0;
  down = 0;
}

void Polozka::kresli() {
  setcolor(popredi);
  setfillstyle(1, pozadi);
  bar(x, y, x + sirka, y + vyska);
  outtextxy(x + 2, y + 2, text);
  obnovit = 0;
}

void Polozka::setBarva(barva pop, barva poz) {
  popredi = pop;
  pozadi = poz;
  obnovit = 1;
}

void Polozka::setOn() { on = 1; resetDown();}
void Polozka::resetOn() { on = 0; resetDown();}
void Polozka::setDown() { down = 1;}
void Polozka::resetDown() { down = 0;}

void Polozka::setText(char *t) {
  text = t;
  obnovit = 1;
}

int Polozka::getX() { return x;}
int Polozka::getY() { return y;}
int Polozka::getSirka() { return sirka;}
int Polozka::getVyska() { return vyska;}
int Polozka::getObnovit() { return obnovit;}
int Polozka::getOn() { return on;}
int Polozka::getDown() { return down;}

class Prvek {
 public:
  Polozka *obsah;
  Prvek *dalsi;

  Prvek(Polozka *p) {
    obsah = p;
    dalsi = NULL;
  }

  ~Prvek() {
    delete obsah;
  }
};

class Menu {

  mouse mys;
  int obnovit;

  Prvek *prvni, *posledni;

 public:
  Menu();
  ~Menu();

  void add(Polozka*);
  void kresli();
  void testMouse();
};

Menu::Menu() {
  int gd=0, gm=0;
  initgraph(&gd, &gm, "");
  prvni = posledni = NULL;
  mys.set_on();
  obnovit = 1;
}

Menu::~Menu() {
  Prvek *pomoc = prvni;
  while (pomoc != NULL) {
    prvni = pomoc->dalsi;
    delete pomoc;
    pomoc = prvni;
  }
  closegraph();
}

void Menu::add(Polozka *p) {
  Prvek *pomoc;
  pomoc = new Prvek(p);
  if (posledni != NULL) posledni->dalsi = pomoc;
  else prvni = pomoc;
  posledni = pomoc;
}

void Menu::kresli() {
  Prvek *pomoc = prvni;
  while (pomoc != NULL) {
    if (pomoc->obsah->getObnovit() || obnovit) {
      mys.set_off();
      pomoc->obsah->kresli();
      mys.set_on();
    }
    pomoc = pomoc->dalsi;
  }
  obnovit = 0;
}

void Menu::testMouse() {
  Prvek *pomoc = prvni;
  mys.aktual();
  int mm = mys.move();
  while (pomoc != NULL) {
    if (mm) {
      if (
	(mys.get_x() > pomoc->obsah->getX())&&
	(mys.get_x() < (pomoc->obsah->getX() + pomoc->obsah->getSirka()))&&
	(mys.get_y() > pomoc->obsah->getY())&&
	(mys.get_y() < (pomoc->obsah->getY() + pomoc->obsah->getVyska()))
	 ) {
	if (!pomoc->obsah->getOn()) pomoc->obsah->mouseOn();
	pomoc->obsah->setOn();
      }
      else {
	if (pomoc->obsah->getOn()) pomoc->obsah->mouseOff();
	pomoc->obsah->resetOn();
      }
    }
    if (pomoc->obsah->getOn()) {
      if (mys.get_left()) pomoc->obsah->setDown();
      else if (pomoc->obsah->getDown()) {
	pomoc->obsah->resetDown();
	pomoc->obsah->mouseClick();
      }
    }
    pomoc = pomoc->dalsi;
  }
}

class Tlacitko : public Polozka {
  int zmackle;
 public:
  Tlacitko(int xx, int yy, int s, int v) : Polozka(xx, yy, s, v) {
    zmackle = 0;
  }

  void mouseOn() {
    if (zmackle) setBarva(12, 3);
    else setBarva(12, 1);
  }

  void mouseOff() {
    if (zmackle) setBarva(14, 3);
    else setBarva(14, 1);
  }

  void mouseClick() {
    if (!zmackle) zmackle = 1;
    else zmackle = 0;
    if (zmackle) setBarva(12, 3);
    else mouseOn();
  }
};

int kon = 0;
int konec() {
  return kon;
}

void konec(int k) {
  kon = k;
}

class Ukonceni : public Polozka {
 public:
  Ukonceni(int xx, int yy, int s, int v) : Polozka(xx, yy, s, v) {}

  void mouseOn() {
    setBarva(14, 4);
  }

  void mouseOff() {
    setBarva(12, 1);
  }

  void mouseClick() {
    konec(1);
  }
};


class Panel : public Menu {

 public:
  void start();
};

void Panel::start() {
  while (!kbhit()&&!konec()) {
    testMouse();
    kresli();
  }
}


void main() {
  Panel PanelR;
  Tlacitko *p;
  p = new Tlacitko(500, 10, 80, 10);
  p->setText("Ahoj");
  PanelR.add(p);
  p = new Tlacitko(500, 30, 80, 10);
  p->setText("Zdar");
  PanelR.add(p);
  p = new Tlacitko(500, 50, 80, 10);
  p->setText("Cau");
  PanelR.add(p);

  Ukonceni *u;
  u = new Ukonceni(500, 70, 80, 10);
  u->setText("Konec");
  u->setBarva(12, 1);
  PanelR.add(u);

  PanelR.start();
}