#include <graphics.h>
#include "polozka.h"
#include "mys.h"

#define NULL 0

class Prvek {
 public:
  Polozka *obsah;
  Prvek *dalsi;

  Prvek(Polozka *p) {
    obsah = p;
    dalsi = NULL;
  }

  ~Prvek() {
    delete obsah;
  }
};

class Menu {

  mouse mys;
  int obnovit;

  Prvek *prvni, *posledni;

 public:
  Menu();
  ~Menu();

  void add(Polozka*);
  void kresli();
  void testMouse();
};

Menu::Menu() {
  int gd=0, gm=0;
  initgraph(&gd, &gm, "");
  prvni = posledni = NULL;
  mys.set_on();
  obnovit = 1;
}

Menu::~Menu() {
  Prvek *pomoc = prvni;
  while (pomoc != NULL) {
    prvni = pomoc->dalsi;
    delete pomoc;
    pomoc = prvni;
  }
  closegraph();
}

void Menu::add(Polozka *p) {
  Prvek *pomoc;
  pomoc = new Prvek(p);
  if (posledni != NULL) posledni->dalsi = pomoc;
  else prvni = pomoc;
  posledni = pomoc;
}

void Menu::kresli() {
  Prvek *pomoc = prvni;
  while (pomoc != NULL) {
    if (pomoc->obsah->getObnovit() || obnovit) {
      mys.set_off();
      pomoc->obsah->kresli();
      mys.set_on();
    }
    pomoc = pomoc->dalsi;
  }
  obnovit = 0;
}

void Menu::testMouse() {
  Prvek *pomoc = prvni;
  mys.aktual();
  int mm = mys.move();
  while (pomoc != NULL) {
    if (mm) {
      if (
	(mys.get_x() > pomoc->obsah->getX())&&
	(mys.get_x() < (pomoc->obsah->getX() + pomoc->obsah->getSirka()))&&
	(mys.get_y() > pomoc->obsah->getY())&&
	(mys.get_y() < (pomoc->obsah->getY() + pomoc->obsah->getVyska()))
	 ) {
	if (!pomoc->obsah->getOn()) pomoc->obsah->mouseOn();
	pomoc->obsah->setOn();
      }
      else {
	if (pomoc->obsah->getOn()) pomoc->obsah->mouseOff();
	pomoc->obsah->resetOn();
      }
    }
    if (pomoc->obsah->getOn()) {
      if (mys.get_left()) pomoc->obsah->setDown();
      else if (pomoc->obsah->getDown()) {
	pomoc->obsah->resetDown();
	pomoc->obsah->mouseClick();
      }
    }
    pomoc = pomoc->dalsi;
  }
}
